package edu.gmu.cs475;


import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Map;

public class KeyValueClient extends AbstractKeyValueClient {

	public KeyValueClient(String host, int port) {
		super(host, port);
	}

	public KeyValueClient(IKeyValueServer server) {
		super(server);
	}

	/**
	 * Prints out all keys that have are directly nested within the given
	 * directory. Must internally synchronize to guarantee that the list of keys
	 * within a directory does not change during its call, and that each key returned
	 * does not change during its execution (using a read/write lock). You should acquire
	 * all of the locks, then read all of the keys and release the locks. Your code should not
	 * deadlock while waiting to acquire locks.
	 * <p>
	 * Your implementation must follow exactly this scheme:
	 * 1. Acquire all locks
	 * 2. Read all values
	 * 3. Release all locks
	 * (You may not release any locks until you are finished reading)
	 *
	 * @param directory to search within
	 * @return A map of every key=value pair directly contained by the given directory
	 * @throws IllegalArgumentException if the key does not represent a directory (does not end in a /)
	 * @throws IllegalArgumentException if the key does not start with a /
	 * @throws RemoteException          if any IOException occurs in the underlying RMI operation
	 */
	public Map<String, String> getAll(String directory) throws IllegalArgumentException, RemoteException {
		return new HashMap<>();
	}

	/**
	 * Sets the content for all keys that are directly contained by the given directory.
	 * Must internally synchronize to guarantee that the list of keys in the given directory does
	 * not change during its call, and that each key being set does not
	 * change during its execution (using a read/write lock)
	 * <p>
	 * Given two concurrent calls to putAll, it will be indeterminite
	 * which call happens first and which happens last. But what you can (and
	 * must) guarantee is that all keys affected will have the *same* value (and not
	 * some the result of the first, and some the result of the second). Your
	 * code should not deadlock while waiting to acquire locks.
	 * <p>
	 * Your implementation must follow exactly this scheme:
	 * 1. Acquire all locks
	 * 2. Write all values
	 * 3. Release all locks
	 * (You may not release any locks until you are finished writing)
	 *
	 * @param directory Directory to do updates within
	 * @param content   The content to write out to each key
	 * @throws IllegalArgumentException if the key does not represent a directory (does not end in a /)
	 * @throws IllegalArgumentException if the key does not start with a /
	 * @throws RemoteException          if any IOException occurs in the underlying RMI operation
	 */
	public void putAll(String directory, String content) throws RemoteException, IllegalArgumentException {

	}

	/**
	 * A callback for you to implement to let you know that a lock was
	 * successfully acquired, and that you should start sending heartbeats for
	 * it
	 *
	 * @param name
	 * @param forWrite
	 * @param stamp
	 */
	public void lockKeySuccess(String name, boolean forWrite, long stamp) {

	}

	/**
	 * A callback for you to implement to let you know a lock was relinquished,
	 * and that you should stop sending heartbeats for it.
	 *
	 * @param name
	 * @param forWrite
	 * @param stamp
	 */
	public void unlockKeyCalled(String name, boolean forWrite, long stamp) {

	}
}
