package edu.gmu.cs475;


import java.nio.file.DirectoryNotEmptyException;
import java.rmi.RemoteException;
import java.util.Collections;
import java.util.List;
import java.util.Set;

public class KeyValueServer extends AbstractKeyValueServer {

	/**
	 * Retrieve an element from this key value store
	 *
	 * @param key the key to retrieve
	 * @return The value mapped to this key, if one exists, otherwise null
	 * @throws NullPointerException     if key is null
	 * @throws IllegalArgumentException if the key represents a directory (ends in /)
	 * @throws IllegalArgumentException if the key does not start with a /
	 */
	public String get(String key) {
		return null;
	}

	/**
	 * Lists all of the keys that are currently known to this key-value store
	 * <p>
	 * * @return A set containing all currently valid keys
	 */
	public Set<String> listKeys() {
		return _listKeys();
	}

	/**
	 * Sets a key to be the given value
	 *
	 * @param key   key to set
	 * @param value value to store
	 * @throws NullPointerException     if key or value is null
	 * @throws IllegalArgumentException if key does not start with a /
	 * @throws IllegalArgumentException if key represents a direcotry (ends with a /)
	 */
	public void set(String key, String value) {

	}

	/**
	 * Removes this key and any values stored at it from the map
	 *
	 * @param key key to remove
	 * @return true if the key was successfully deleted, or false if it did not exist
	 * @throws NullPointerException     if key is null
	 * @throws IllegalArgumentException if key does not start with a /
	 * @throws IllegalArgumentException if key represents a directory (ends with a /)
	 */
	public boolean remove(String key) {
		return false;
	}

	/**
	 * Lists the contents of a directory (non-recursively)
	 *
	 * @param directory path of the directory
	 * @return unsorted set of the files and directories inside of this directory, or null if the directory doesn't exist.
	 * @throws NullPointerException     if key is null
	 * @throws IllegalArgumentException if the key does not represent a directory (does not end in a /)
	 * @throws IllegalArgumentException if the key does not start with a /
	 */
	public Set<String> listDirectory(String directory) {
		return null;
	}

	/**
	 * Deletes an empty directory
	 *
	 * @param directory path of the directory
	 * @throws IllegalArgumentException   if the key does not represent a directory (does not end in a /)
	 * @throws IllegalArgumentException   if the key does not start with a /
	 * @throws DirectoryNotEmptyException if the directory is not empty
	 */
	public void removeDirectory(String directory) throws DirectoryNotEmptyException {

	}

	/**
	 * Acquires a read or write lock for a given key. Accepts any valid key (directory or non).
	 *
	 * @param key      Key to lock
	 * @param forWrite True if a write lock is requested, else false
	 * @return A stamp representing the lock owner (e.g. from a StampedLock)
	 * @throws IllegalArgumentException If the key doesn't exist
	 */
	public long lockKey(String key, boolean forWrite) throws IllegalArgumentException {
		return 0;
	}

	/**
	 * Releases a read or write lock for a given key. Accepts any valid key (directory or non).
	 *
	 * @param key      Key to lock
	 * @param stamp    the Stamp representing the lock owner (returned from lockKey)
	 * @param forWrite True if a write lock is requested, else false
	 * @throws IllegalArgumentException     If the key doesn't exist
	 * @throws IllegalMonitorStateException if the stamp specified is not (or is no longer) valid
	 */
	public void unLockKey(String key, long stamp, boolean forWrite) throws IllegalArgumentException, IllegalMonitorStateException {

	}

	/**
	 * Notifies the server that the client is still alive and well, still using
	 * the lock specified by the stamp provided
	 *
	 * @param key     The key (same exact name passed to lockKey) that we are
	 *                reporting in on
	 * @param stampId Stamp returned from lockKey that we are reporting in on
	 * @param isWrite if the heartbeat is for a write lock
	 * @throws IllegalMonitorStateException if the stamp specified is not (or is no longer) valid, or if
	 *                                      the stamp is not valid for the given read/write state
	 * @throws IllegalArgumentException     if the key specified doesn't exist
	 */
	public void heartbeat(String key, long stampId, boolean isWrite) throws RemoteException, IllegalArgumentException {

	}

	/**
	 * Get a list of all of the keys that are currently write locked
	 */
	@Override
	public List<String> getWriteLockedKeys() throws RemoteException {
		return Collections.emptyList();
	}

	/**
	 * Get a list of all of the keys that are currently write locked
	 */
	@Override
	public List<String> getReadLockedKeys() throws RemoteException {
		return Collections.emptyList();
	}
}
