package edu.gmu.cs475;

import java.io.IOException;
import java.nio.file.DirectoryNotEmptyException;
import java.nio.file.NoSuchFileException;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.List;
import java.util.Map;
import java.util.Set;

public interface IKeyValueServer extends Remote {
    public static final String RMI_NAME = "cs475IKeyValueStore";

    String get(String key) throws RemoteException;

    Set<String> listKeys() throws RemoteException;

    void set(String key, String value) throws RemoteException;

    boolean remove(String key) throws RemoteException;

    Set<String> listDirectory(String directory) throws RemoteException;

    void removeDirectory(String directory) throws RemoteException, DirectoryNotEmptyException;

    long lockKey(String name, boolean forWrite) throws RemoteException;

    void unLockKey(String name, long stamp, boolean forWrite) throws RemoteException;

    void heartbeat(String file, long stampId, boolean isWrite) throws RemoteException, IllegalMonitorStateException, IllegalArgumentException;

    List<String> getWriteLockedKeys() throws RemoteException;

    List<String> getReadLockedKeys() throws RemoteException;
}
